﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Silanis.ESL.SDK;
using Silanis.ESL.SDK.Builder;
using Silanis.ESL.SDK.Internal;
using System.Diagnostics;
using System.Net;
using System.Net.Http;
using System.Net.Http.Headers;
using Newtonsoft.Json.Linq;
using Newtonsoft.Json;

namespace completionReport
{
    class completionReport
    {
        private static string API_KEY = "api_key";
	    private static string API_URL = "https://sandbox.esignlive.com/api";
	    public static EslClient eslClient = new EslClient(API_KEY, API_URL);

	    public static void Main(string[] args) {
		
		    // Date and time range to get completion/usage report.
            DateTime from = DateTime.Now.AddDays(-10);
 
            DateTime to = DateTime.Now;
        
            getCompletionReport(DocumentPackageStatus.DRAFT, from, to);
            getCompletionReport(DocumentPackageStatus.COMPLETED, from, to);
            getCompletionReport(DocumentPackageStatus.SENT, from, to);
 
	    }
	
	    public static void getCompletionReport (DocumentPackageStatus status, DateTime from, DateTime to) {
    	
		    // Download the completion report for all senders
            CompletionReport sdkCompletionReport = eslClient.ReportService.DownloadCompletionReport(status, from, to);
        
            if (sdkCompletionReport == null) {
        	   Debug.WriteLine("\nNo packages in " + status.ToString() + " folder");
            } else {
        	    // Display package id and name of packages in DRAFT from sender
                Debug.WriteLine("");
                foreach (SenderCompletionReport senderCompletionReport in sdkCompletionReport.Senders) {
                    Debug.WriteLine("Sender: " + senderCompletionReport.Sender.Email);
                    Debug.WriteLine(" has " + senderCompletionReport.Packages.Count + " packages in " + status.ToString());
     
                    foreach (PackageCompletionReport packageCompletionReport in senderCompletionReport.Packages) {
                       Debug.WriteLine(packageCompletionReport.Id + " , " + packageCompletionReport.Name + " , Sender : " + eslClient.GetPackage(new PackageId(packageCompletionReport.Id)).SenderInfo.Email);
                    }
                }
            } 
        
        }
    }
}
